// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/include/24dsi16wrc_utils.h $
// $Rev: 52512 $
// $Date: 2023-03-01 12:44:05 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Utilities: header file

#ifndef	__24DSI16WRC_UTILS_H__
#define	__24DSI16WRC_UTILS_H__

#include "24dsi16wrc_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	dsi16wrc_close_util			(int fd, int index, int verbose);
int dsi16wrc_init_util			(int verbose);
int dsi16wrc_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	dsi16wrc_open_util			(int device, int share, int index, int verbose, int* fd);
int	dsi16wrc_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	dsi16wrc_adc_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_ADC_MODE
int	dsi16wrc_ai_buf_clear		(int fd, int index, int verbose);								// DSI16WRC_IOCTL_AI_BUF_CLEAR
int	dsi16wrc_ai_buf_enable		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_BUF_ENABLE
int	dsi16wrc_ai_buf_fill_lvl	(int fd, int index, int verbose, s32* get);						// DSI16WRC_IOCTL_AI_BUF_FILL_LVL
int	dsi16wrc_ai_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_BUF_OVERFLOW
int	dsi16wrc_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// DSI16WRC_IOCTL_AI_BUF_THR_STS
int	dsi16wrc_ai_buf_thresh		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_BUF_THRESH
int	dsi16wrc_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_BUF_UNDERFLOW
int	dsi16wrc_ai_channel_tag		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_CHANNEL_TAG
int	dsi16wrc_ai_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AI_MODE
int	dsi16wrc_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// DSI16WRC_IOCTL_AUTO_CAL_STS
int	dsi16wrc_auto_calibrate		(int fd, int index, int verbose);								// DSI16WRC_IOCTL_AUTO_CALIBRATE
int	dsi16wrc_aux_clk_ctl_mode	(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AUX_CLK_CTL_MODE
int	dsi16wrc_aux_sync_ctl_mode	(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE
int	dsi16wrc_burst				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_BURST
int	dsi16wrc_burst_rate_div		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_BURST_RATE_DIV
int	dsi16wrc_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_BURST_SIZE
int	dsi16wrc_burst_timer		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_BURST_TIMER
int	dsi16wrc_burst_trigger		(int fd, int index, int verbose);								// DSI16WRC_IOCTL_BURST_TRIGGER
int	dsi16wrc_ch_grp_0_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_CH_GRP_0_SRC
int	dsi16wrc_ch_grp_1_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_CH_GRP_1_SRC
int	dsi16wrc_channels_ready		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_CHANNELS_READY
int	dsi16wrc_control_mode		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_CONTROL_MODE
int	dsi16wrc_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_DATA_FORMAT
int	dsi16wrc_data_width			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_DATA_WIDTH
int	dsi16wrc_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_DIO_DIR_OUT
int	dsi16wrc_dio_read			(int fd, int index, int verbose, s32* get);						// DSI16WRC_IOCTL_DIO_READ
int	dsi16wrc_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_DIO_WRITE
int	dsi16wrc_ext_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_EXT_CLK_SRC
int	dsi16wrc_ext_sync_in		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_EXT_SYNC_IN
int	dsi16wrc_initialize			(int fd, int index, int verbose);								// DSI16WRC_IOCTL_INITIALIZE
int	dsi16wrc_irq_sel			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_IRQ_SEL
int	dsi16wrc_master_clk_adj		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_MASTER_CLK_ADJ
int	dsi16wrc_ndiv				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_NDIV
int	dsi16wrc_nref				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_NREF
int	dsi16wrc_nvco				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_NVCO
int	dsi16wrc_query				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_QUERY
int	dsi16wrc_range				(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RANGE
int	dsi16wrc_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// DSI16WRC_IOCTL_REG_MOD
int	dsi16wrc_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// DSI16WRC_IOCTL_REG_READ
int	dsi16wrc_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// DSI16WRC_IOCTL_REG_WRITE
int	dsi16wrc_rx_io_abort		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RX_IO_ABORT
int	dsi16wrc_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RX_IO_MODE
int	dsi16wrc_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RX_IO_OVERFLOW
int	dsi16wrc_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RX_IO_TIMEOUT
int	dsi16wrc_rx_io_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_RX_IO_UNDERFLOW
int	dsi16wrc_sw_sync			(int fd, int index, int verbose);								// DSI16WRC_IOCTL_SW_SYNC
int	dsi16wrc_sw_sync_mode		(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_SW_SYNC_MODE
int	dsi16wrc_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI16WRC_IOCTL_WAIT_CANCEL
int	dsi16wrc_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI16WRC_IOCTL_WAIT_EVENT
int	dsi16wrc_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI16WRC_IOCTL_WAIT_STATUS
int	dsi16wrc_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// DSI16WRC_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	dsi16wrc_channel_group		(int fd, int index, int verbose, int channel, s32* group);
int	dsi16wrc_config_ai			(int fd, int index, int verbose, s32 fref, s32 fsamp);
int	dsi16wrc_fsamp_ai_compute	(int fd, int index, int verbose, s32 fref, s32 fsamp, s32* mode, s32* nvco, s32* nref, s32* ndiv, s32* mca, double* rate);
int	dsi16wrc_fsamp_ai_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	dsi16wrc_fsamp_ai_report_all(int fd, int index, int verbose, s32* fsamp);
int	dsi16wrc_fsamp_ai_validate	(int fd, int index, int verbose, s32 fsamp);
int	dsi16wrc_id_device			(int fd, int index, int verbose);

int	dsi16wrc_count_boards		(int verbose, s32* get);
int	dsi16wrc_reg_list			(int fd, int detail);

const gsc_reg_def_t*			dsi16wrc_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*			dsi16wrc_reg_get_def_index		(int index);
const char*						dsi16wrc_reg_get_desc			(u32 reg);
const char*						dsi16wrc_reg_get_name			(u32 reg);



#endif
