// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/fsamp/perform.c $
// $Rev: 52497 $
// $Date: 2023-03-01 12:31:03 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	s32		fref;
	int		fsamp;
	s32		max;
	s32		mca;
	s32		min;
	s32		mode;
	s32		ndiv;
	s32		nref;
	s32		nvco;
	double	rate;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
		errs	+= dsi16wrc_query(args->fd, -1, 0, DSI16WRC_QUERY_FREF_DEFAULT, &fref);
	}
	else
	{
		errs	+= dsi16wrc_query(args->fd, -1, 0, DSI16WRC_QUERY_FSAMP_MAX, &max);
		errs	+= dsi16wrc_query(args->fd, -1, 0, DSI16WRC_QUERY_FSAMP_MIN, &min);
		errs	+= dsi16wrc_query(args->fd, -1, 0, DSI16WRC_QUERY_FREF_DEFAULT, &fref);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 24DSI16WRC Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= dsi16wrc_fsamp_ai_compute(args->fd, -1, 1, fref, fsamp, &mode, &nvco, &nref, &ndiv, &mca, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (double) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


