// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/id/perform.c $
// $Rev: 52498 $
// $Date: 2023-03-01 12:31:22 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Zero Test, +Vref Test\n");
}



//*****************************************************************************
static void _resolution(void)
{
	gsc_label("Resolution");
	printf("24/20/18/16-bit\n");
}



//*****************************************************************************
static int _id_device_bcfgr(const args_t* args)
{
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= dsi16wrc_reg_get_def_id(DSI16WRC_GSC_BCFGR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dsi16wrc_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. dsi16wrc_reg_get_def_id, DSI16WRC_GSC_BCFGR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= dsi16wrc_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_input_modes();
	_resolution();

	for (i = 0; i < DSI16WRC_QUERY_LAST; i++)
		errs	+= dsi16wrc_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_bcfgr(args);
	errs	+= _register_map(args);

	return(errs);
}


