// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/irq/main_dma.c $
// $Rev: 49244 $
// $Date: 2021-04-06 12:48:51 -0500 (Tue, 06 Apr 2021) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _irq_check_support(void)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[200];
	int		errs		= 0;
	int		got;

	errs	+= dsi16wrc_config_ai		(fd, -1, 0, -1, 250000);
	errs	+= dsi16wrc_rx_io_mode		(fd, -1, 0, GSC_IO_MODE_DMDMA, NULL);
	errs	+= dsi16wrc_rx_io_overflow	(fd, -1, 0, DSI16WRC_IO_OVERFLOW_IGNORE, NULL);

	os_sleep_ms(50);

	got	= dsi16wrc_read(fd, buf, sizeof(buf));

	if (got < 0)
	{
		errs++;
		printf("ERROR: dsi16wrc_read() failure\n");
	}

	return(errs);
}



//*****************************************************************************
int main_dma_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support();
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


