// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/mbsync/sync.c $
// $Rev: 52507 $
// $Date: 2023-03-01 12:39:11 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
int multi_board_sync(const args_t* args)
{
	int	errs	= 0;

	printf("-- Configuration:\n");

	errs	+= service_config_ai		(args);
	errs	+= service_xcvr_type		(args);
	errs	+= service_fsamp_ai			(args);
	errs	+= service_rx_io_overflow	(args);
	errs	+= service_range			(args);
	errs	+= service_data_width		(args);
	errs	+= service_data_format		(args);
	errs	+= service_auto_calibrate	(args);
	errs	+= service_delay_ms			(args,	100, 0);
	errs	+= service_ai_buf_clear		(args);

	if (args->star)
	{
		printf("-- Configuration: Star\n");
		//													Initiator							Targets
		errs	+= service_control_mode	(args,	DSI16WRC_CONTROL_MODE_INITIATOR,	DSI16WRC_CONTROL_MODE_INITIATOR	);
		errs	+= service_ch_grp_src	(args,	DSI16WRC_CH_GRP_SRC_DIR_EXTERN,		DSI16WRC_CH_GRP_SRC_DIR_EXTERN	);
		errs	+= service_ext_clk_src	(args,	DSI16WRC_EXT_CLK_SRC_GRP_0,			-1								);
	}
	else
	{
		printf("-- Configuration: Daisy-Chain\n");
		//													Initiator							Targets
		errs	+= service_control_mode	(args,	DSI16WRC_CONTROL_MODE_INITIATOR,	DSI16WRC_CONTROL_MODE_TARGET	);
		errs	+= service_ch_grp_src	(args,	DSI16WRC_CH_GRP_SRC_RATE_GEN,		DSI16WRC_CH_GRP_SRC_DIR_EXTERN	);
		errs	+= service_ext_clk_src	(args,	DSI16WRC_EXT_CLK_SRC_GRP_0,			-1								);
	}

	printf("-- Signal Tests:\n");
	errs	+= service_delay_ms			(args,	10, 0);
	errs	+= service_ai_buf_enable	(args,	DSI16WRC_AI_BUF_ENABLE_NO,			DSI16WRC_AI_BUF_ENABLE_NO		);
	errs	+= service_ai_buf_has_data	(args);
	errs	+= service_sw_sync_mode		(args,	DSI16WRC_SW_SYNC_MODE_CLR_BUF,		DSI16WRC_SW_SYNC_MODE_CLR_BUF	);
	errs	+= service_sw_sync			(args);
	errs	+= service_channels_ready	(args);
	errs	+= service_delay_ms			(args,	10, 0);
	errs	+= service_ai_buf_is_empty	(args);
	errs	+= service_ai_buf_enable	(args,	DSI16WRC_AI_BUF_ENABLE_YES,			DSI16WRC_AI_BUF_ENABLE_YES		);
	errs	+= service_delay_ms			(args,	1000, 0);	// let the FIFO fill with data.
	errs	+= service_ai_buf_has_data	(args);

	if (args->sync_none)
	{
		printf("-- Synchronize: NONE\n");
		errs	+= service_ai_buf_clear		(args);
		errs	+= service_channels_ready	(args);
	}
	else
	{
		printf("-- Synchronize: Scans\n");
		//														Initiator						Targets
		errs	+= service_sw_sync_mode		(args,	DSI16WRC_SW_SYNC_MODE_SYNC,		DSI16WRC_SW_SYNC_MODE_SYNC		);
		errs	+= service_sw_sync			(args);
		errs	+= service_channels_ready	(args);

		printf("-- Synchronize: Buffers\n");
		//														Initiator						Targets
		errs	+= service_sw_sync_mode		(args,	DSI16WRC_SW_SYNC_MODE_CLR_BUF,	DSI16WRC_SW_SYNC_MODE_CLR_BUF	);
		errs	+= service_sw_sync			(args);
		errs	+= service_channels_ready	(args);
	}

	return(errs);
}


