// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/savedata/main.h $
// $Rev: 52502 $
// $Date: 2023-03-01 12:32:39 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "24dsi16wrc_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)				(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	d_format;		// data format
	s32	decimal;		// save the data in decimal format?
	s32	force_save;		// Save data even if there are errors?
	s32	fsamp;			// The desired sample rate.
	s32	index;			// device index
	s32	minute_limit;
	s32	repeat;			// repeat data retrieval this many times
	s32	tag_strip;		// Strip the channel tag from the saved data?
	s32	test_limit;

	int	fd;

	// Device Settings

	s32	data_format;
	s32	io_mode;
	s32	v_range;		// The desired voltage range
	s32	width;
	s32	xcvr;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
