// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ai_buf_fill_lvl.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test_empty(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_BUF_ENABLE,
			/* arg		*/	DSI16WRC_AI_BUF_ENABLE_NO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	10,
			/* reg		*/	DSI16WRC_GSC_BUFSR,
			/* mask		*/	0x70000,
			/* value	*/	0x00000
		},

		{ SERVICE_END_LIST }
	};

	s32	arg;
	int	errs	= 0;
	int	ret;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	ret		= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_AI_BUF_FILL_LVL, &arg);
	errs	+= dsi16wrc_initialize(fd, -1, 0);

	if ((ret) || (arg))
		errs++;

	return(errs);
}



//*****************************************************************************
static int _function_test_sync(int fd)
{
	u32	bufsr;
	int	errs	= 0;
	int	i;
	s32	level;
	s32	qty;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_query			(fd, -1, 0, DSI16WRC_QUERY_CHANNEL_QTY, &qty);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_burst_size		(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 1; (errs == 0) && (i <= 16); i++)
	{
		errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
		os_sleep_ms(1);
		errs	+= dsi16wrc_reg_read		(fd, -1, 0, DSI16WRC_GSC_BUFSR, &bufsr);
		level	= bufsr & 0x7FFFF;

		if (level != (i * qty))
		{
			errs++;
			break;
		}

		errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

		if (level != (i * qty))
		{
			errs++;
			break;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	errs	+= _function_test_empty(fd);
	errs	+= _function_test_sync(fd);
	errs	+= _function_test_empty(fd);
	errs	+= _function_test_sync(fd);

	return(errs);
}



/******************************************************************************
*
*	Function:	ai_buf_fill_lvl_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AI_BUF_FILL_LVL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_fill_lvl_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AI_BUF_FILL_LVL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


