// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ai_buf_overflow.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	int	i;
	s32	over;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= dsi16wrc_ndiv			(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_nref			(fd, -1, 0, 25, NULL);
	errs	+= dsi16wrc_nvco			(fd, -1, 0, 300, NULL);
	errs	+= dsi16wrc_ai_buf_overflow	(fd, -1, 0, -1, &over);

	if (over)
		errs++;

	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 0; errs == 0; i++)
	{
		errs	+= dsi16wrc_ai_buf_overflow	(fd, -1, 0, -1, &over);

		if (over)
			break;

		if (i > 50)
		{
			errs++;
			break;
		}

		os_sleep_ms(10);
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ai_buf_overflow_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AI_BUF_OVERFLOW.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_overflow_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AI_BUF_OVERFLOW");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


