// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ai_buf_thr_sts.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	u32	bctlr;
	int	errs	= 0;
	int	i;
	s32	level;
	s32	qty;
	s32	status;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_query			(fd, -1, 0, DSI16WRC_QUERY_CHANNEL_QTY, &qty);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_burst_size		(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 1; (errs == 0) && (i <= 16); i++)
	{
		errs	+= dsi16wrc_burst_trigger(fd, -1, 0);
		os_sleep_ms(1);
		level	= qty * i;

		// Set the threshold 1 above and see that the status is clear
		errs	+= dsi16wrc_ai_buf_thresh	(fd, -1, 0, level + 1, NULL);
		errs	+= dsi16wrc_ai_buf_thr_sts	(fd, -1, 0, &status);
		errs	+= dsi16wrc_reg_read		(fd, -1, 0, DSI16WRC_GSC_BCTLR, &bctlr);

		if (status != DSI16WRC_AI_BUF_THR_STS_IDLE)
			errs++;

		if (bctlr & 0x4000)
			errs++;

		// Set the threshold 1 below and see that the status is set.
		errs	+= dsi16wrc_ai_buf_thresh(fd, -1, 0, level - 1, NULL);
		errs	+= dsi16wrc_ai_buf_thr_sts	(fd, -1, 0, &status);
		errs	+= dsi16wrc_reg_read		(fd, -1, 0, DSI16WRC_GSC_BCTLR, &bctlr);

		if (status != DSI16WRC_AI_BUF_THR_STS_ACTIVE)
			errs++;

		if ((bctlr & 0x4000) == 0)
			errs++;
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ai_buf_thr_sts_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AI_BUF_THR_STS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_thr_sts_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AI_BUF_THR_STS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


