// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ai_buf_thresh.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_BUF_THRESH,
			/* arg		*/	-1,
			/* reg		*/	DSI16WRC_GSC_BUFCR,
			/* mask		*/	-1,
			/* value	*/	-1
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;

	errs	+= dsi16wrc_initialize(fd, -1, 0);

	for (i = -1; i <= 19; i++)
	{
		list[0].arg		= (0x00000 | (0x00001 << i)) & 0x7FFFF;
		list[0].mask	= 0x7FFFF;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);

		list[0].arg		= (0x3FFFF & ~(0x00001 << i)) & 0x7FFFF;
		list[0].mask	= 0x7FFFF;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	ai_buf_thresh_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AI_BUF_THRESH.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_thresh_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AI_BUF_THRESH");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


