// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ai_mode.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_MODE,
			/* arg		*/	DSI16WRC_AI_MODE_DIFF,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x03,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_MODE,
			/* arg		*/	DSI16WRC_AI_MODE_ZERO,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x03,
			/* value	*/	0x02
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AI_MODE,
			/* arg		*/	DSI16WRC_AI_MODE_VREF,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x03,
			/* value	*/	0x03
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	u32	data;
	int	errs	= 0;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_data_format		(fd, -1, 0, DSI16WRC_DATA_FORMAT_OFF_BIN, NULL);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_burst_size		(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	errs	+= dsi16wrc_ai_mode			(fd, -1, 0, DSI16WRC_AI_MODE_ZERO, NULL);
	errs	+= dsi16wrc_auto_calibrate	(fd, -1, 0);
	errs	+= dsi16wrc_ai_buf_clear	(fd, -1, 0);
	errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
	os_sleep_ms(1);
	errs	+= dsi16wrc_reg_read		(fd, -1, 0, DSI16WRC_GSC_IDBR, &data);

	if ((data > (0x8000 + 0xFF)) || (data < (0x8000 - 0xFF)))
		errs++;

	errs	+= dsi16wrc_ai_mode			(fd, -1, 0, DSI16WRC_AI_MODE_VREF, NULL);
	errs	+= dsi16wrc_auto_calibrate	(fd, -1, 0);
	errs	+= dsi16wrc_ai_buf_clear	(fd, -1, 0);
	errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
	os_sleep_ms(1);
	errs	+= dsi16wrc_reg_read		(fd, -1, 0, DSI16WRC_GSC_IDBR, &data);

	if ((data > (0xFEB8 + 0xFF)) || (data < (0xFEB8 - 0xFF)))
		errs++;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ai_mode_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AI_MODE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_mode_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AI_MODE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


