// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/auto_cal_sts.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AUTO_CALIBRATE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs;
	int	ret;
	s32	sts		= 0;

	errs	= dsi16wrc_initialize(fd, -1, 0);
	ret		= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_AUTO_CAL_STS, &sts);

	if ((ret) || (sts != DSI16WRC_AUTO_CAL_STS_PASS))
		errs	= 1;

	errs	+= service_ioctl_set_reg_list(fd, list);

	ret		= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_AUTO_CAL_STS, &sts);

	if ((ret) || (sts != DSI16WRC_AUTO_CAL_STS_PASS))
		errs++;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	auto_cal_sts_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AUTO_CAL_STS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int auto_cal_sts_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AUTO_CAL_STS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


