// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/aux_sync_ctl_mode.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE,
			/* arg		*/	DSI16WRC_AUX_SYNC_CTL_MODE_INACTIVE,
			/* reg		*/	DSI16WRC_GSC_ASIOCR,
			/* mask		*/	0x0C,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE,
			/* arg		*/	DSI16WRC_AUX_SYNC_CTL_MODE_INPUT,
			/* reg		*/	DSI16WRC_GSC_ASIOCR,
			/* mask		*/	0x0C,
			/* value	*/	0x04
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE,
			/* arg		*/	DSI16WRC_AUX_SYNC_CTL_MODE_OUTPUT,
			/* reg		*/	DSI16WRC_GSC_ASIOCR,
			/* mask		*/	0x0C,
			/* value	*/	0x08
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	aux_sync_ctl_mode_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aux_sync_ctl_mode_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


