// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/burst.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_BURST,
			/* arg		*/	DSI16WRC_BURST_DISABLE,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x200000,
			/* value	*/	0x000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_BURST,
			/* arg		*/	DSI16WRC_BURST_ENABLE,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x200000,
			/* value	*/	0x200000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	s32	level;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= dsi16wrc_ndiv			(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_nref			(fd, -1, 0, 25, NULL);
	errs	+= dsi16wrc_nvco			(fd, -1, 0, 300, NULL);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_burst_size		(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);
	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level > 0)
		errs++;

	errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
	os_sleep_ms(1);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level == 0)
		errs++;

	errs	+= dsi16wrc_ai_buf_clear	(fd, -1, 0);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_DISABLE, NULL);
	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level == 0)
		errs++;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	burst_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_BURST.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int burst_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_BURST");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


