// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/burst_size.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_BURST_SIZE,
			/* arg		*/	-1,
			/* reg		*/	DSI16WRC_GSC_BBSR,
			/* mask		*/	-1,
			/* value	*/	-1
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;

	errs	+= dsi16wrc_initialize(fd, -1, 0);

	for (i = -1; i < 24; i++)
	{
		list[0].arg		= (0x00000 | (0x00001 << i)) & 0xFFFFFF;
		list[0].mask	= 0xFFFFFF;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);

		list[0].arg		= (0xFFFFFF & ~(0x00001 << i)) & 0xFFFFFF;
		list[0].mask	= 0xFFFFFF;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	int	i;
	s32	level;
	s32	qty;
	s32	sum		= 0;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_ndiv			(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_nref			(fd, -1, 0, 25, NULL);
	errs	+= dsi16wrc_nvco			(fd, -1, 0, 300, NULL);
	errs	+= dsi16wrc_query			(fd, -1, 0, DSI16WRC_QUERY_CHANNEL_QTY, &qty);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 1; i < 32; i++)
	{
		errs	+= dsi16wrc_burst_size	(fd, -1, 0, i, NULL);
		errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
		os_sleep_ms(1);
		errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);
		sum		+= i * qty;

		if (sum != level)
			errs++;
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	burst_size_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_BURST_SIZE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int burst_size_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_BURST_SIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


