// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/burst_trigger.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	s32	level;
	s32	qty;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_query			(fd, -1, 0, DSI16WRC_QUERY_CHANNEL_QTY, &qty);
	errs	+= dsi16wrc_burst			(fd, -1, 0, DSI16WRC_BURST_ENABLE, NULL);
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);
	errs	+= dsi16wrc_burst_size		(fd, -1, 0, 1, NULL);

	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level != 0)
		errs++;

	errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level != qty)
		errs++;

	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level != qty)
		errs++;

	errs	+= dsi16wrc_burst_trigger	(fd, -1, 0);
	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level != (qty * 2))
		errs++;

	os_sleep_ms(10);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

	if (level != (qty * 2))
		errs++;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	burst_trigger_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_BURST_TRIGGER.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int burst_trigger_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_BURST_TRIGGER");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


