// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/ch_grp_0_src.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_CH_GRP_0_SRC,
			/* arg		*/	DSI16WRC_CH_GRP_SRC_RATE_GEN,
			/* reg		*/	DSI16WRC_GSC_CSAR,
			/* mask		*/	0xF,
			/* value	*/	0x0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_CH_GRP_0_SRC,
			/* arg		*/	DSI16WRC_CH_GRP_SRC_EXTERN,
			/* reg		*/	DSI16WRC_GSC_CSAR,
			/* mask		*/	0xF,
			/* value	*/	0x4
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_CH_GRP_0_SRC,
			/* arg		*/	DSI16WRC_CH_GRP_SRC_DIR_EXTERN,
			/* reg		*/	DSI16WRC_GSC_CSAR,
			/* mask		*/	0xF,
			/* value	*/	0x5
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_CH_GRP_0_SRC,
			/* arg		*/	DSI16WRC_CH_GRP_SRC_DISABLE,
			/* reg		*/	DSI16WRC_GSC_CSAR,
			/* mask		*/	0xF,
			/* value	*/	0x6
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	ch_grp_0_src_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_CH_GRP_0_SRC.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ch_grp_0_src_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_CH_GRP_0_SRC");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


