// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/dio_write.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	data;
	u32	diopr;
	int	errs	= 0;
	int	i;

	errs	+= dsi16wrc_initialize	(fd, -1, 0);
	errs	+= dsi16wrc_dio_dir_out	(fd, -1, 0, 0xF, NULL);

	for (i = 0; i <= 0xF; i++)
	{
		errs	+= dsi16wrc_dio_write(fd, -1, 0, i, NULL);
		errs	+= dsi16wrc_dio_read(fd, -1, 0, &data);

		if (data != i)
			errs++;

		errs	+= dsi16wrc_reg_read(fd, -1, 0, DSI16WRC_GSC_DIOPR, &diopr);

		if ((diopr & 0xF) != i)
			errs++;
	}

	errs	+= dsi16wrc_initialize	(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	dio_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_DIO_WRITE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_DIO_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


