// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/irq_sel.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_INIT_DONE,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_AUTO_CAL_DONE,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_CHAN_READY,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_AI_BUF_THRESH_L2H,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x300
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_AI_BUF_THRESH_H2L,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_IRQ_SEL,
			/* arg		*/	DSI16WRC_IRQ_AI_BURST_DONE,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x700,
			/* value	*/	0x500
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This functionality is tested via the Wait Event service.
	return(0);
}



/******************************************************************************
*
*	Function:	irq_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_IRQ_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_IRQ_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


