// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/nref.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_NREF,
			/* arg		*/	-1,
			/* reg		*/	DSI16WRC_GSC_RCR,
			/* mask		*/	-1,
			/* value	*/	-1
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;

	errs	+= dsi16wrc_initialize(fd, -1, 0);

	for (i = 25; i <= 300; i += 5)
	{
		list[0].arg		= i;
		list[0].mask	= 0xFFF000;
		list[0].value	= list[0].arg << 12;

		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);
	}

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	nref_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_NREF.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int nref_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_NREF");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


