// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/perform.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	if (args->verbose)
	{
		// Perform only those tests that generate verbose output.

		gsc_label("Tests To Perform");
		printf("Only tests with verbose output.\n");

		errs	+= ai_buf_clear_test(args);				// DSI16WRC_IOCTL_AI_BUF_CLEAR
	}
	else
	{
		// Perform all tests.
		errs	+= reg_read_test(args->fd);				// DSI16WRC_IOCTL_REG_READ
		errs	+= reg_write_test(args->fd);			// DSI16WRC_IOCTL_REG_WRITE
		errs	+= reg_mod_test(args->fd);				// DSI16WRC_IOCTL_REG_MOD
		errs	+= query_test(args->fd);				// DSI16WRC_IOCTL_QUERY
		errs	+= initialize_test(args->fd);			// DSI16WRC_IOCTL_INITIALIZE
		errs	+= auto_calibrate_test(args->fd);		// DSI16WRC_IOCTL_AUTO_CALIBRATE
		errs	+= auto_cal_sts_test(args->fd);			// DSI16WRC_IOCTL_AUTO_CAL_STS
		errs	+= adc_mode_test(args->fd);				// DSI16WRC_IOCTL_ADC_MODE
		errs	+= ai_buf_clear_test(args);				// DSI16WRC_IOCTL_AI_BUF_CLEAR
		errs	+= ai_buf_enable_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_ENABLE
		errs	+= ai_buf_fill_lvl_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_FILL_LVL
		errs	+= ai_buf_overflow_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_OVERFLOW
		errs	+= ai_buf_thresh_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_THRESH
		errs	+= ai_buf_thr_sts_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_THR_STS
		errs	+= ai_buf_underflow_test(args->fd);		// DSI16WRC_IOCTL_AI_BUF_UNDERFLOW
		errs	+= ai_channel_tag_test(args->fd);		// DSI16WRC_IOCTL_AI_CHANNEL_TAG
		errs	+= ai_mode_test(args->fd);				// DSI16WRC_IOCTL_AI_MODE
		errs	+= aux_clk_ctl_mode_test(args->fd);		// DSI16WRC_IOCTL_AUX_CLK_CTL_MODE
		errs	+= aux_sync_ctl_mode_test(args->fd);	// DSI16WRC_IOCTL_AUX_SYNC_CTL_MODE
		errs	+= burst_test(args->fd);				// DSI16WRC_IOCTL_BURST
		errs	+= burst_rate_div_test(args->fd);		// DSI16WRC_IOCTL_BURST_RATE_DIV
		errs	+= burst_size_test(args->fd);			// DSI16WRC_IOCTL_BURST_SIZE
		errs	+= burst_timer_test(args->fd);			// DSI16WRC_IOCTL_BURST_TIMER
		errs	+= burst_trigger_test(args->fd);		// DSI16WRC_IOCTL_BURST_TRIGGER
		errs	+= ch_grp_0_src_test(args->fd);			// DSI16WRC_IOCTL_CH_GRP_0_SRC
		errs	+= ch_grp_1_src_test(args->fd);			// DSI16WRC_IOCTL_CH_GRP_1_SRC
		errs	+= channels_ready_test(args->fd);		// DSI16WRC_IOCTL_CHANNELS_READY
		errs	+= control_mode_test(args->fd);			// DSI16WRC_IOCTL_CONTROL_MODE
		errs	+= data_format_test(args->fd);			// DSI16WRC_IOCTL_DATA_FORMAT
		errs	+= data_width_test(args->fd);			// DSI16WRC_IOCTL_DATA_WIDTH
		errs	+= dio_dir_out_test(args->fd);			// DSI16WRC_IOCTL_DIO_DIR_OUT
		errs	+= dio_read_test(args->fd);				// DSI16WRC_IOCTL_DIO_READ
		errs	+= dio_write_test(args->fd);			// DSI16WRC_IOCTL_DIO_WRITE
		errs	+= ext_clk_src_test(args->fd);			// DSI16WRC_IOCTL_EXT_CLK_SRC
		errs	+= irq_sel_test(args->fd);				// DSI16WRC_IOCTL_IRQ_SEL
		errs	+= master_clk_adj_test(args->fd);		// DSI16WRC_IOCTL_MASTER_CLK_ADJ
		errs	+= ndiv_test(args->fd);					// DSI16WRC_IOCTL_NDIV
		errs	+= nref_test(args->fd);					// DSI16WRC_IOCTL_NREF
		errs	+= nvco_test(args->fd);					// DSI16WRC_IOCTL_NVCO
		errs	+= range_test(args->fd);				// DSI16WRC_IOCTL_RANGE
		errs	+= rx_io_abort_test(args->fd);			// DSI16WRC_IOCTL_RX_IO_ABORT
		errs	+= rx_io_mode_test(args->fd);			// DSI16WRC_IOCTL_RX_IO_MODE
		errs	+= rx_io_overflow_test(args->fd);		// DSI16WRC_IOCTL_RX_IO_OVERFLOW
		errs	+= rx_io_timeout_test(args->fd);		// DSI16WRC_IOCTL_RX_IO_TIMEOUT
		errs	+= rx_io_underflow_test(args->fd);		// DSI16WRC_IOCTL_RX_IO_UNDERFLOW
		errs	+= sw_sync_test(args->fd);				// DSI16WRC_IOCTL_SW_SYNC
		errs	+= sw_sync_mode_test(args->fd);			// DSI16WRC_IOCTL_SW_SYNC_MODE
		errs	+= wait_event_test(args->fd);			// DSI16WRC_IOCTL_WAIT_EVENT
		errs	+= wait_cancel_test(args->fd);			// DSI16WRC_IOCTL_WAIT_CANCEL
		errs	+= wait_status_test(args->fd);			// DSI16WRC_IOCTL_WAIT_STATUS
		errs	+= xcvr_type_test(args->fd);			// DSI16WRC_IOCTL_XCVR_TYPE
		errs	+= ext_sync_in_test(args->fd);			// DSI16WRC_IOCTL_EXT_SYNC_IN
	}

	return(errs);
}


