// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/query.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	errs	= dsi16wrc_query(fd, -1, 0, DSI16WRC_QUERY_COUNT, &count);

	if (errs)
	{
	}
	else if (count != (DSI16WRC_QUERY_LAST - 1))
	{
		errs	= 1;
	}
	else
	{
		for (i = 0; (errs == 0) && (i < DSI16WRC_QUERY_LAST); i++)
		{
			errs	= dsi16wrc_query(fd, -1, 0, i, &data);

			if (errs)
				break;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


