// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/range.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	alt[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_1_25V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_2_5V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x04
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_5V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x08
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_10V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x0C
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	std[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_10MV,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_100MV,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x04
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_1V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x08
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI16WRC_IOCTL_RANGE,
			/* arg		*/	DSI16WRC_RANGE_10V,
			/* reg		*/	DSI16WRC_GSC_BCTLR,
			/* mask		*/	0x0C,
			/* value	*/	0x0C
		},

		{ SERVICE_END_LIST }
	};

	int						errs	= 0;
	const service_data_t*	list;
	s32						range;

	errs	+= dsi16wrc_query(fd, -1, 0, DSI16WRC_QUERY_V_RANGE, &range);
	list	= (range == DSI16WRC_QUERY_V_RANGE_10_BY_10) ? std : alt;

	errs	+= dsi16wrc_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= dsi16wrc_initialize(fd, -1, 0);


	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	range_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_RANGE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int range_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_RANGE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


