// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/reg_read.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const struct
	{
		u32	reg;
		u32	value;
	} list[]	=
	{
		// reg					value
		{ DSI16WRC_GSC_BCTLR,	0		},
		{ DSI16WRC_GSC_RCR,		0		},
		{ DSI16WRC_GSC_DIOPR,	0		},
		{ DSI16WRC_GSC_CSAR,	0		},
		{ DSI16WRC_GSC_RDR,		0		},
		{ DSI16WRC_GSC_BBSR,	0		},
		{ DSI16WRC_GSC_BUFCR,	0		},
		{ DSI16WRC_GSC_BCFGR,	0		},
		{ DSI16WRC_GSC_BUFSR,	0		},
		{ DSI16WRC_GSC_AVR,		0		},
		{ DSI16WRC_GSC_IDBR,	0		},
		{ DSI16WRC_GSC_ASIOCR,	0		},
		{ DSI16WRC_GSC_MCAR,	0		},
		{ DSI16WRC_GSC_BTTR,	0		},

		{ GSC_PCI_9080_VIDR,	0x10B5	},
		{ GSC_PCI_9080_DIDR,	0		},
		{ GSC_PCI_9080_SVID,	0x10B5	},
		{ GSC_PCI_9080_SID,		0		},

		{ GSC_PLX_9080_VIDR,	0x10B5	},
		{ GSC_PLX_9080_DIDR,	0		}
	};

	int			errs	= 0;
	int			i;
	int			j;
	gsc_reg_t	parm;

	for (i = 0; i < (int) SIZEOF_ARRAY(list); i++)
	{
		parm.reg	= list[i].reg;
		parm.value	= 0xDEADBEEF;
		parm.mask	= 0xBEEFDEAD;
		j			= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_REG_READ, (void*) &parm);

		if (j)
		{
			errs	= 1;
			break;
		}

		if (parm.value == 0xDEADBEEF)
		{
			errs	= 1;
			break;
		}

		if (parm.mask != 0xBEEFDEAD)
		{
			errs	= 1;
			break;
		}

		if ((list[i].value) && (parm.value != list[i].value))
		{
			errs	= 1;
			break;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



/******************************************************************************
*
*	Function:	reg_read_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_REG_READ.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int reg_read_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_REG_READ");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


