// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/reg_write.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const struct
	{
		u32	reg;
		u32	value;
		u32	mask;
	} list[]	=
	{
		// reg					value		mask
		{ DSI16WRC_GSC_BCTLR,	0x0000013F,	0x0000073F	},
		{ DSI16WRC_GSC_BCTLR,	0x00000000,	0x0000073F	},

		{ DSI16WRC_GSC_CSAR,	0x00000044,	0x000000FF	},
		{ DSI16WRC_GSC_CSAR,	0x00000000,	0x000000FF	},

		{ DSI16WRC_GSC_RDR,		0x00000005,	0x000000FF	},
		{ DSI16WRC_GSC_RDR,		0x00000001,	0x000000FF	},

		{ DSI16WRC_GSC_BUFCR,	0x00009999,	0x0003FFFF	},
		{ DSI16WRC_GSC_BUFCR,	0x0003FFFE,	0x0003FFFF	},
	};

	int			errs	= 0;
	int			i;
	int			j;
	gsc_reg_t	parm;

	for (i = 0; i < (int) SIZEOF_ARRAY(list); i++)
	{
		parm.reg	= list[i].reg;
		parm.value	= list[i].value;
		parm.mask	= 0xBEEFDEAD;
		j			= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_REG_WRITE, (void*) &parm);

		if (j)
		{
			errs	= 1;
			break;
		}

		if (parm.mask != 0xBEEFDEAD)
		{
			errs	= 1;
			break;
		}

		// Now read the register and verify the bits of interest.
		j	= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_REG_WRITE, (void*) &parm);

		if (j)
		{
			errs	= 1;
			break;
		}

		if ((list[i].value & list[i].mask) != (parm.value & list[i].mask))
		{
			errs	= 1;
			break;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



/******************************************************************************
*
*	Function:	reg_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_REG_WRITE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int reg_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_REG_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


