// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sbtest/sw_sync.c $
// $Rev: 52509 $
// $Date: 2023-03-01 12:40:28 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	int	i;
	s32	level;

	// Initialize the device.
	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	errs	+= dsi16wrc_ndiv			(fd, -1, 0, 1, NULL);
	errs	+= dsi16wrc_nref			(fd, -1, 0, 25, NULL);
	errs	+= dsi16wrc_nvco			(fd, -1, 0, 300, NULL);
	errs	+= dsi16wrc_control_mode	(fd, -1, 0, DSI16WRC_CONTROL_MODE_INITIATOR, NULL);

	// Test the Clear Buffer on Sync mode.
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 0; errs == 0; i++)
	{
		os_sleep_ms(10);
		errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

		if (level)
			break;

		if (i > 50)
		{
			errs++;
			break;
		}
	}

	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_NO, NULL);
	errs	+= dsi16wrc_sw_sync_mode	(fd, -1, 0, DSI16WRC_SW_SYNC_MODE_CLR_BUF, NULL);
	errs	+= dsi16wrc_sw_sync			(fd, -1, 0);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);
	os_sleep_ms(10);

	if (level)
		errs++;

	// Test the Sync mode, which also clears the buffer.
	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_YES, NULL);

	for (i = 0; errs == 0; i++)
	{
		os_sleep_ms(10);
		errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);

		if (level)
			break;

		if (i > 50)
		{
			errs++;
			break;
		}
	}

	errs	+= dsi16wrc_ai_buf_enable	(fd, -1, 0, DSI16WRC_AI_BUF_ENABLE_NO, NULL);
	errs	+= dsi16wrc_sw_sync_mode	(fd, -1, 0, DSI16WRC_SW_SYNC_MODE_SYNC, NULL);
	errs	+= dsi16wrc_sw_sync			(fd, -1, 0);
	errs	+= dsi16wrc_ai_buf_fill_lvl	(fd, -1, 0, &level);
	os_sleep_ms(10);

	if (level)
		errs++;

	errs	+= dsi16wrc_initialize		(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	sw_sync_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI16WRC_IOCTL_SW_SYNC.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sw_sync_test(int fd)
{
	int	errs	= 0;

	gsc_label("DSI16WRC_IOCTL_SW_SYNC");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs)
		printf("FAIL <---\n");
	else
		printf("PASS\n");

	return(errs);
}


