// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/samples/sw_sync/perform.c $
// $Rev: 52504 $
// $Date: 2023-03-01 12:33:19 -0600 (Wed, 01 Mar 2023) $

// 24DSI16WRC: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	char	buf[64];
	time_t	end;
	int		errs	= 0;
	s32		fref;
	time_t	now;
	int		ret;

	errs	+= dsi16wrc_initialize			(args->fd, -1, 1);
	errs	+= dsi16wrc_control_mode		(args->fd, -1, 1, DSI16WRC_CONTROL_MODE_INITIATOR, NULL);
	errs	+= dsi16wrc_xcvr_type			(args->fd, -1, 1, DSI16WRC_XCVR_TYPE_TTL, NULL);
	errs	+= dsi16wrc_query				(args->fd, -1, 1, DSI16WRC_QUERY_FREF_DEFAULT, &fref);
	errs	+= dsi16wrc_master_clk_adj		(args->fd, -1, 1, 0x8000, NULL);
	errs	+= dsi16wrc_nvco				(args->fd, -1, 1, 30, NULL);
	errs	+= dsi16wrc_nref				(args->fd, -1, 1, 30, NULL);
	errs	+= dsi16wrc_ext_clk_src			(args->fd, -1, 1, DSI16WRC_EXT_CLK_SRC_GEN, NULL);

	sprintf(buf, "Working (%d seconds)", args->seconds);
	gsc_label(buf);
	end	= time(NULL) + args->seconds;

	for (; errs == 0;)
	{
		ret		= dsi16wrc_ioctl(args->fd, DSI16WRC_IOCTL_SW_SYNC, NULL);
		errs	= ret ? 1 : 0;
		now		= time(NULL);

		if (now > end)
			break;

		gsc_time_sleep_ms(1);
	}

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



