// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/utils/util_ai_buf_clear.c $
// $Rev: 49274 $
// $Date: 2021-04-29 22:18:23 -0500 (Thu, 29 Apr 2021) $

// 24DSI16WRC: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi16wrc_ai_buf_clear
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI16WRC_IOCTL_AI_BUF_CLEAR service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi16wrc_ai_buf_clear(int fd, int index, int verbose)
{
	int	errs	= 0;
	int	ret;

	if (verbose)
		gsc_label_index("AI Buffer Clear", index);

	ret		= dsi16wrc_ioctl			(fd, DSI16WRC_IOCTL_AI_BUF_CLEAR, NULL);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


