// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/utils/util_ai_buf_thresh.c $
// $Rev: 44343 $
// $Date: 2019-01-28 15:13:50 -0600 (Mon, 28 Jan 2019) $

// 24DSI16WRC: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi16wrc_ai_buf_thresh
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI16WRC_IOCTL_AI_BUF_THRESH service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi16wrc_ai_buf_thresh(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs	= 0;
	int	ret;

	if (verbose)
		gsc_label_index("AI Buffer Threshold", index);

	ret		= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_AI_BUF_THRESH, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s  (%ld)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


