// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI16WRC/utils/util_dio_read.c $
// $Rev: 49274 $
// $Date: 2021-04-29 22:18:23 -0500 (Thu, 29 Apr 2021) $

// 24DSI16WRC: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi16wrc_dio_read
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI16WRC_IOCTL_DIO_READ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi16wrc_dio_read(int fd, int index, int verbose, s32* get)
{
	int	errs	= 0;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("Digital I/O Read", index);

	ret		= dsi16wrc_ioctl(fd, DSI16WRC_IOCTL_DIO_READ, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%04lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


